#include <iostream>
#include "comm.h"
#include <stdio.h>
#include "windows.h"

#define PROX_THR 800
#define PROX_AMB_THR 900
#define GROUND_THR 400
#define GROUND_AMB_THR 1000
#define OK_TIMES 10
#define ACC_POS_THR 40
#define ACC_NEG_THR -40
#define ACC_Z_THR -80

#define BUFFER_SIZE 74

using namespace std;

unsigned char proxValueOk[8] = {0};
unsigned char proxValueOkCounter[8] = {0};
unsigned char proxValueAmbientOk[8] = {0};
unsigned char proxValueAmbientOkCounter[8] = {0};
unsigned char groundValueOk[4] = {0};
unsigned char groundValueOkCounter[4] = {0};
unsigned char groundValueAmbientOk[4] = {0};
unsigned char groundValueAmbientOkCounter[4] = {0};
unsigned int proxValue[8] = {0};
unsigned int groundValue[4] = {0};
unsigned char button=1, buttonOk=0;
unsigned char rfFlags=0, rfSpiOk=0, rfRadioOk=0;

signed int accXmin=1000, accXmax=-1000, accYmin=1000, accYmax=-1000, accZmin=1000;
signed int accX=0, accY=0, accZ=0;

unsigned char selectorOk=0, tvRemoteOk=0;
unsigned char selector=0, tvRemote=0;
unsigned int groundValueAmbient[4] = {0};
unsigned int proxValueAmbient[8] = {0};

void curPos(int x, int y) {
  HANDLE hStdout;
  CONSOLE_SCREEN_BUFFER_INFO csbiInfo;
  hStdout=GetStdHandle(STD_OUTPUT_HANDLE);
  GetConsoleScreenBufferInfo(hStdout, &csbiInfo);
  csbiInfo.dwCursorPosition.X=x;
  csbiInfo.dwCursorPosition.Y=y;
  SetConsoleCursorPosition(hStdout, csbiInfo.dwCursorPosition);
}

void printData(unsigned char *data) {

    unsigned int i=0;

    proxValue[0] = ((signed int)data[1]<<8)|(unsigned char)data[0];
    proxValueAmbient[0] = ((signed int)data[3]<<8)|(unsigned char)data[2];
    proxValue[1] = ((signed int)data[5]<<8)|(unsigned char)data[4];
    proxValueAmbient[1] = ((signed int)data[7]<<8)|(unsigned char)data[6];
    proxValue[2] = ((signed int)data[9]<<8)|(unsigned char)data[8];
    proxValueAmbient[2] = ((signed int)data[11]<<8)|(unsigned char)data[10];
    proxValue[3] = ((signed int)data[13]<<8)|(unsigned char)data[12];
    proxValueAmbient[3] = ((signed int)data[15]<<8)|(unsigned char)data[14];
    proxValue[4] = ((signed int)data[17]<<8)|(unsigned char)data[16];
    proxValueAmbient[4] = ((signed int)data[19]<<8)|(unsigned char)data[18];
    proxValue[5] = ((signed int)data[21]<<8)|(unsigned char)data[20];
    proxValueAmbient[5] = ((signed int)data[23]<<8)|(unsigned char)data[22];
    proxValue[6] = ((signed int)data[25]<<8)|(unsigned char)data[24];
    proxValueAmbient[6] = ((signed int)data[27]<<8)|(unsigned char)data[26];
    proxValue[7] = ((signed int)data[29]<<8)|(unsigned char)data[28];
    proxValueAmbient[7] = ((signed int)data[31]<<8)|(unsigned char)data[30];

    groundValue[0] = ((signed int)data[33]<<8)|(unsigned char)data[32];
    groundValueAmbient[0] = ((signed int)data[35]<<8)|(unsigned char)data[34];
    groundValue[1] = ((signed int)data[37]<<8)|(unsigned char)data[36];
    groundValueAmbient[1] = ((signed int)data[39]<<8)|(unsigned char)data[38];
    groundValue[2] = ((signed int)data[41]<<8)|(unsigned char)data[40];
    groundValueAmbient[2] = ((signed int)data[43]<<8)|(unsigned char)data[42];
    groundValue[3] = ((signed int)data[45]<<8)|(unsigned char)data[44];
    groundValueAmbient[3] = ((signed int)data[47]<<8)|(unsigned char)data[46];

    accX = (int)(((signed char)data[49]<<8)|((signed char)data[48]));
    accY = (int)(((signed char)data[51]<<8)|((signed char)data[50]));
    accZ = (int)(((signed char)data[53]<<8)|((signed char)data[52]));

    tvRemote = (unsigned char)data[54];

    selector = (unsigned char)data[55];

    button = (unsigned char)data[56];

    rfFlags = (unsigned char)data[57];

    curPos(0,0);
    HANDLE hOut;
    hOut = GetStdHandle(STD_OUTPUT_HANDLE);


    printf("***Premere ESC per ritornare al menu***\n\r\n");

    printf("PROXIMITY\r\n");
    printf("Sen0  Sen1  Sen2  Sen3  Sen4  Sen5  Sen6  Sen7\r\n");
    for(i=0; i<8; i++) {
        if(!proxValueOk[i]) {
            SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
            printf("%4d  ", proxValue[i]);
            if(proxValue[i] >= PROX_THR) {
                proxValueOkCounter[i]++;
                if(proxValueOkCounter[i] >= OK_TIMES) { // avoid glitches due maybe to communication
                    proxValueOk[i]=1;
                }
            } else {
                proxValueOkCounter[i]=0;
            }
        } else {
            SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
            printf("%4d  ", proxValue[i]);
        }
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("PROXIMITY AMBIENT\r\n");
    printf("Sen0  Sen1  Sen2  Sen3  Sen4  Sen5  Sen6  Sen7\r\n");
    for(i=0; i<8; i++) {
        if(!proxValueAmbientOk[i]) {
            SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
            printf("%4d  ", proxValueAmbient[i]);
            if(proxValueAmbient[i] >= PROX_AMB_THR) {
                proxValueAmbientOkCounter[i]++;
                if(proxValueAmbientOkCounter[i] >= OK_TIMES) {
                    proxValueAmbientOk[i]=1;
                }
            } else {
                proxValueAmbientOkCounter[i]=0;
            }
        } else {
            SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
            printf("%4d  ", proxValueAmbient[i]);
        }
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("GROUND\r\n");
    printf("Sen0  Sen1  Sen2  Sen3\r\n");
    for(i=0; i<4; i++) {
        if(!groundValueOk[i]) {
            SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
            printf("%4d  ", groundValue[i]);
            if(groundValue[i] <= GROUND_THR) {
                groundValueOkCounter[i]++;
                if(groundValueOkCounter[i] >= OK_TIMES) {
                    groundValueOk[i]=1;
                }
            } else {
                groundValueOkCounter[i]=0;
            }
        } else {
            SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
            printf("%4d  ", groundValue[i]);
        }
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("GROUND AMBIENT\r\n");
    printf("Sen0  Sen1  Sen2  Sen3\r\n");
    for(i=0; i<4; i++) {
        if(!groundValueAmbientOk[i]) {
            SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
            printf("%4d  ", groundValueAmbient[i]);
            if(groundValueAmbient[i] >= GROUND_AMB_THR) {
                groundValueAmbientOkCounter[i]++;
                if(groundValueAmbientOkCounter[i] >= OK_TIMES) {
                    groundValueAmbientOk[i]=1;
                }
            } else {
                groundValueAmbientOkCounter[i]=0;
            }
        } else {
            SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
            printf("%4d  ", groundValueAmbient[i]);
        }
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("ACCELEROMETER\r\n");
    if(accX < accXmin) {
        accXmin = accX;
    }
    if(accX > accXmax) {
        accXmax = accX;
    }
    if(accY < accYmin) {
        accYmin = accY;
    }
    if(accY > accYmax) {
        accYmax = accY;
    }
    if(accZ < accZmin) {
        accZmin = accZ;
    }
    if(accXmin <= ACC_NEG_THR && accXmax >= ACC_POS_THR) {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("X:%4d\t", accX);
    } else {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("X:%4d\t", accX);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    if(accYmin <= ACC_NEG_THR && accYmax >= ACC_POS_THR) {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("Y:%4d\t", accY);
    } else {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("Y:%4d\t", accY);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    if(accZmin <= ACC_Z_THR) {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("Z:%4d\t", accZ);
    } else {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("Z:%4d\t", accZ);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("TV REMOTE\r\n");
    if(!tvRemoteOk) {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("%.2d", tvRemote);
        if(tvRemote == 51) {
            tvRemoteOk=1;
        }
    } else {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("%.2d", tvRemote);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("SELECTOR\r\n");
    if(!selectorOk) {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("%.2d", selector);
        if(selector == 6) {
            selectorOk=1;
        }
    } else {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("%.2d", selector);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("BUTTON\r\n");
    if(!buttonOk) {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("pressed=%d", 1-button);
        if(button==0) {
            buttonOk=1;
        }
    } else {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("pressed=%d", 1-button);
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");

    printf("RADIO\r\n");
    if(!rfSpiOk) {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("Chip ON\t");
        if(rfFlags & 0x01) {
            rfSpiOk=1;
        }
    } else {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("Chip ON\t");
    }
    if(!rfRadioOk) {
        SetConsoleTextAttribute(hOut, 0+15*16); // black text on white background
        printf("Radio OK");
        if(rfFlags & 0x02) {
            rfRadioOk=1;
        }
    } else {
        SetConsoleTextAttribute(hOut, 0+2*16); // black text on green background
        printf("Radio OK");
    }
    SetConsoleTextAttribute(hOut, 15+0*16); // white text on black background
    printf("\n\r\n");
}

void printMenu() {
    printf("***************\r\n");
    printf("MENU PRINCIPALE\r\n");
    printf("***************\r\n\n");
    printf("1) TESTING\n\r\n");
    printf("2) ADDRESS SETTING\n\r\n");
    printf("0) EXIT\n\r\n");
    printf("\n\n");
}

int main() {

    int err=0, i=0, port=1, rfAddress=0, choice=0;
    unsigned char running = 1;
    char portStr[20]={0};
    TCommPort *comm;
    unsigned char data[BUFFER_SIZE];

    HANDLE hOut;
    hOut = GetStdHandle(STD_OUTPUT_HANDLE);
    // Set up the required window size:
    SMALL_RECT windowSize = {0, 0, 79, 49};
    // Change the console window size:
    SetConsoleWindowInfo(hOut, TRUE, &windowSize);

    printf("\r\nINSERIRE NUMERO PORTA SERIALE (ES. 3 PER COM3): ");
    scanf("%d", &port);
    sprintf(portStr, "COM%d", port);
    comm = new TCommPort();
    comm->SetCommPort(portStr);
    comm->SetBaudRate(57600);
    comm->SetParity(NOPARITY);      // NOPARITY and friends are #defined in windows.h
    comm->SetByteSize(8);
    comm->SetStopBits(ONESTOPBIT);  // ONESTOPBIT is also from windows.h
    err = comm->OpenCommPort();
    if(err==-1) {
        std::cerr << "NUMERO PORTA SBAGALIATO!" << std::endl;
        Sleep(3000);
        return -1;
    }
    comm->FlushCommPort();
    comm->PurgeCommPort();

    printMenu();

    while(running) {
        comm->FlushCommPort();
        comm->PurgeCommPort();
        system( "cls" );
        printMenu();
        printf("SCELTA: ");
        fflush(stdin);
        scanf("%d", &choice);

        if(choice == 0) {
            break;
        }
        //printf("choice=%d\r\n", choice);
        //Sleep(2000);
        if(choice <= 2) {
            data[0] = choice;
            comm->WriteBuffer((BYTE*)data, 1);
        }

        system( "cls" );

        for(i=0; i<8; i++) {
            proxValueOk[i]=0;
            proxValueOkCounter[i]=0;
            proxValueAmbientOk[i]=0;
            proxValueAmbientOkCounter[i]=0;
        }
        for(i=0; i<4; i++) {
            groundValueOk[i]=0;
            groundValueOkCounter[i]=0;
            groundValueAmbientOk[i]=0;
            groundValueAmbientOkCounter[i]=0;
        }
        accXmin=1000;
        accXmax=-1000;
        accYmin=1000;
        accYmax=-1000;
        accZmin=1000;
        tvRemoteOk=0;
        selectorOk=0;
        buttonOk=0;
        rfSpiOk=0;
        rfRadioOk=0;

        switch(choice) {

            case 1:
                while(1) {
                    if(GetKeyState (VK_ESCAPE) < 0) {     // 'ESC'
                        data[0] = 0x55;
                        comm->WriteBuffer((BYTE*)data, 1);
                        comm->FlushCommPort();
                        break;
                    }
                    data[0] = 0xAA; // ack
                    comm->WriteBuffer((BYTE*)data, 1);
                    comm->FlushCommPort();
                    memset(data, 0x00, BUFFER_SIZE);
                    comm->ReadBytes((BYTE*)data, BUFFER_SIZE, 200000);
                    printData(data);
                }
                break;

            case 2:
                while(1) {
                    printf("INDIRIZZO (0 per uscire): ");
                    scanf("%d", &rfAddress);
                    if(rfAddress == 0) {
                        break;
                    } else {
                        // send address
                        data[0] = rfAddress;
                        data[1] = rfAddress>>8;
                        //printf("LSB=%x\r\n", data[0]);
                        //printf("MSB=%x\r\n", data[1]);
                        //Sleep(1000);
                        if(rfAddress < 3200) {
                            printf("INDIRIZZO PROBABILMENTE ERRATO, RIPROVARE!\r\n");
                            Sleep(2000);
                            continue;
                        }
                        comm->WriteBuffer((BYTE*)data, 2);
                        memset(data, 0x00, BUFFER_SIZE);
                        comm->ReadBytes((BYTE*)data, 1, 200000);
                        // printf confirmation
                        if(data[0] == 0xAA) {
                            printf("INDIRIZZO %d SALVATO CORRETTAMENTE!\r\n", rfAddress);
                        } else {
                            printf("INDIRIZZO NON SALVATO, RIPROVARE!\r\n");
                        }
                        Sleep(2000);
                        break;
                    }
                }
                break;

            default:
                printf("SCELTA NON VALIDA!\r\n");
                Sleep(1000);
                break;
        }

    }

    return 0;
}
